4d3d08acb87e0a32999bce3aa5de511a1cb8aa46
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies:
19 # lsdvd dvdauthor gddrescue dvdbackup makexml tovid mencoder vlc mplayer genisoimage
20 #
21 # Optional Dependencies:
22 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
23 #
24
25 ###############################################
26 # Local Machine Settings - EDIT THIS SECTION
27
28 # Specify the device path to the DVD drive
29 dev=/dev/dvd2
30
31 # Specify the path to the log directory 
32 logdir=/var/log/ripdvd
33
34 # Specify the path to the tmp rip directory
35 tmpdir=/myth/video/DVDs/.ripdvd
36
37 # Specify the email address to send job notifications to
38 mailto=ajp@pippins.net
39
40 # Setup the path to the tools needed by this ripper
41 PATH=/etc/mythtv/bin:/usr/local/bin:/usr/sbin:/sbin:/usr/bin:.:$PATH
42
43 # Use mplayer dumpstream to create the main VOB file
44 # If set to 0, cat and other utils will be used to make it instead.
45 # Using mplayer dumpstream is by far the best way to create the main VOB file
46 # The only thing this doesn't work for are DVDs with the 99 title copy protection.
47 # The script will autodetect these types of disks, and change this to 0 if necessary.
48 # If this is set to 0, other methods will be employed to get the DVD VOB dump.
49 use_mplayer_dumpstream=1
50
51 # 2-channel AVI encoding audio bit rate
52 audio_bitrate=224
53
54 # If set to 1, this script will call another script to fill in the mythvideo metadata
55 # If you don't use mythtv, set this option to 0. If you use mythtv, and have downloaded
56 # the fill_mythvideo_metadata.pl script shown above, you can leave this option set to 1.
57 fill_mythvideo_metadata=1
58
59 # If the 99 titleset copy protection scheme is detected, trust the autodetection or abort.
60 # The autodetection may work, but it probably won't in this case. Set to 0 by default. 
61 # Override to 1 if you want the script to wing it, and hope it picks the right feature title.
62 # Otherwise, you will need to rerun the script providing the feature title with the -t option.
63 trust_feature_title_autodetect_when_uncertain=0
64
65 ###############################################
66 # Command line processing
67 typeset dvdname=""
68 typeset debug=""
69 typeset dest=""
70 typeset isofile=""
71 typeset vobfile=""
72 typeset dvdpath=""
73 typeset -i keep_intermediate_files=0
74 typeset -i make_final_dest_vob=0
75 typeset -i make_final_dest_iso=0
76 typeset -i make_final_dest_folder=0
77 typeset -i make_final_dest_avi=0
78 typeset -i errors=0
79 typeset -i show_usage=0
80 typeset -i mirror_mode=0
81 typeset -i target_bitrate=0
82 typeset -i target_size=0
83 typeset -i audio_2ch=0
84 typeset -i invalid_feature_title=0
85 typeset -i feature_title_override=0
86 typeset -i mplayer_dumpstream_incompatibility=0
87
88 while (($#)) && getopts 2mvifkxht:n:d:b:s:t: opt "$@"
89 do
90     case $opt in
91         (n)     dvdname=$OPTARG;;
92         (d)     dest=$OPTARG;;
93         (b)     target_bitrate=$OPTARG;;
94         (s)     target_size=$OPTARG;;
95         (2)     audio_2ch=1;;
96         (v)     make_final_dest_vob=1;;
97         (i)     make_final_dest_iso=1;;
98         (f)     make_final_dest_folder=1;; 
99         (x)     make_final_dest_avi=1;;
100         (m)     mirror_mode=1;;
101         (k)     keep_intermediate_files=1;;
102         (t)     feature_title_override=$OPTARG;;
103         (w)     set -$opt;;
104         (h)     show_usage=1;;
105         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
106         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
107     esac
108 done
109
110 shift $((OPTIND-1))
111
112 function usage() {
113     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
114     echo >&2 "Revision $REV"
115     echo >&2 "Options:"
116     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
117     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
118     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
119     echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
120     echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
121     echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
122     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
123     echo >&2 "                 The default operation is non-mirror mode where only the main"
124     echo >&2 "                 feature title will be ripped."
125     echo >&2 "   -v            Make the final image a DVD VOB file"
126     echo >&2 "   -i            Make the final image a DVD ISO file"
127     echo >&2 "   -f            Make the final image a DVD folder"
128     echo >&2 "   -x            Make the final image an AVI (XVID) file"
129     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
130     echo >&2 "   -s <size>     Set the target size of the AVI file in MB (ex: 700, 1000, etc)"
131     echo >&2 "   -b <bitrate>  Set the bitrate desired in the AVI file in kbits/sec (ex: 1500, 2000 (default), etc)"    
132     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making an AVI file (default is 6 channel AC3)"
133     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
134     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
135     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
136     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
137     echo >&2 "   -w            Set the sh Execute/Verbose flag"
138     echo >&2 ""
139     exit 2
140 }
141
142 if (($errors)) || (($show_usage))
143 then
144   usage
145 fi
146
147 # Sanity Check - Command Line Options 
148 if [ "$dest" == "" ]; then
149   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
150   usage
151 fi
152
153 if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ]) && [ $make_final_dest_avi -ne 1 ]; then
154   echo "-E- You can't specify a bitrate in non AVI file mode. You must specify '-x' when using '-b' or '-s'" | tee -a $logfile
155   usage
156 fi
157
158 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_avi -eq 1 ]; then
159   echo "-E- You must specify a bitrate in AVI file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
160   usage
161 fi
162
163 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
164    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_avi -eq 0 ] && [ $mirror_mode -eq 0 ]; then
165   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
166   usage
167 fi
168
169 if [ $mirror_mode -eq 1 ]; then
170   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
171      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
172     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
173     usage
174   fi
175 fi
176
177 # Sanity Check - Key executables
178 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
179 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
180 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
181 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
182 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
183 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
184 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
185 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
186
187 ###############################################
188
189 typeset -i ripdvd
190 if [ -z "$dvdname" ]; then
191   # make sure the DVD device is accessible
192   volname $dev > /dev/null 2>&1
193   if [ $? != 0 ]; then
194     echo "-E- Can't access the DVD device $dev"
195     exit 1
196   fi
197   # now capture the volume name from the device
198   dvdname=`volname $dev | awk '{ print $1 }'`
199   ripdvd=1
200 else 
201   # check to see if dvdname is a full path to a real directory
202   # if it is, set dvdname and dvdpath appropriately
203   if [ -d "$dvdname" ]; then
204     dvdpath="$dvdname"
205     dvdname=`basename "$dvdname"`
206     if [ -z "$dvdname" ]; then
207      echo "-E- Unable to extract dvdname from path: $dvdpath"
208      exit 1
209     fi
210     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
211       echo "-E- You must supply a full path to a valid DVD folder with this option"
212       exit 1
213     fi
214   fi
215   # check to see if dvdname is a full path to an MPG2 (VOB) file
216   # if it is, set dvdname and vobfile appropriately
217   if [ -f "$dvdname" ]; then
218     vobfile="$dvdname"
219     dvdname=`basename "$dvdname"`
220     file "$vobfile" | grep -q "MPEG"
221     if [ $? == 0 ]; then
222       # It is a valid MPEG2 file, now strip the extension off our dvdname
223       dvdname=${dvdname%.[^.]*}
224     else 
225       echo "-E- Unsupported file type: $vobfile"
226       exit 1
227     fi
228   fi
229   ripdvd=0
230 fi
231
232 # Make sure we have a non-empty dvdname
233 if [ -z "$dvdname" ]; then
234   echo "-E- unable to determine dvdname"
235   exit 1
236 fi
237
238 # make sure our vobfile value is set
239 if [ -z "$vobfile" ]; then
240   vobfile="$dest/$dvdname.VOB"
241 fi
242
243 # make a "safe" dvdname (remove special characters)
244 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
245
246 # set up some variables to hold various logfiles
247 logfile="$logdir/$dvdname.log"
248 passlogfile="$tmpdir/$safedvdname.log"
249 ddrescuelog=`tempfile`
250 dvdauthorlog=`tempfile`
251 encodelog=`tempfile`
252 dumplog=`tempfile`
253
254 # create the tmpdir if it doesn't already exist
255 if [ ! -d "$tmpdir" ]; then
256   mkdir -p "$tmpdir"
257   if [ $? != 0 ]; then
258     echo "-E- Unable to create the tmpdir: $tmpdir"
259     exit 1
260   fi
261 fi
262
263 # create the logdir if it doesn't already exist
264 if [ ! -d "$logdir" ]; then
265   mkdir -p "$logdir"
266   if [ $? != 0 ]; then
267     echo "-E- Unable to create the logdir: $logdir"
268     exit 1
269   fi
270 fi
271
272 ###############################################
273 # cleanup functions
274 cleanup() { 
275   if [ $keep_intermediate_files -eq 0 ]; then
276     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
277     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
278     [[ -e "$encodelog" ]] && rm -f "$encodelog"
279     [[ -e "$dumplog" ]] && rm -f "$dumplog"
280   else
281     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
282     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
283     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
284     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
285   fi
286   echo ""
287 }
288
289 fatal_and_exit() {
290   if [[ -z "$1" ]]; then
291     msg="-E- control-c killed us"
292   else
293     msg=$1
294   fi
295   echo -e 2>&1 "$msg" | tee -a "$logfile"
296   if [[ -n "$mailto" ]]; then
297     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
298   fi
299   exit 1
300 }
301
302 # Call our cleanup functions on INT and EXIT signals
303 trap fatal_and_exit INT
304 trap cleanup EXIT
305
306 ###############################################
307 # processing functions
308 function make_dvd_iso_image {
309
310   isofile="$1"
311
312   # check to see if we have a dvdpath to rip from instead of $dev
313   if [ -z "$dvdpath" ]; then
314     # load the CSS codes in the DVD drive 
315     lsdvd $dev >> "$logfile"
316     if [ $? != 0 ]; then
317       fatal_and_exit "-E- lsdvd $dev failed" 
318     fi
319
320     # read the DVD, ignoring/skipping CRC errors
321     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
322     if [ $? != 0 ]; then
323       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
324     fi
325     cat "$ddrescuelog" >> "$logfile"
326   else
327     # rip from a path instead
328     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
329   fi
330 }
331
332 function make_dvd_iso_image_from_folder {
333   
334   src="$1"
335   dst="$2"
336   handle_error=$3
337   
338   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
339
340   # make an iso image out of our directory
341   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
342   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
343
344   # make sure we were able to create the iso image from the folder given to us
345   if [ ! -s "$tmpdir/$dvdname.iso" ] && [ $handle_error -eq 1 ]; then
346     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
347     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
348     # get the feature title from the DVD folder
349     get_feature_title "$dvdpath"
350     # create our main VOB file from the ISO
351     create_main_vob_with_mplayer "$dvdpath"
352   fi
353 }
354
355 function make_dvdbackup_folder_image {
356   # extract the feature title from the DVD image
357   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
358   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
359   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
360   if [ $? != 0 ]; then
361     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
362   fi
363 }
364
365 function make_dvdauthor_folder_image {
366   # create a new DVD video of the feature title
367   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
368   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
369   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
370   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
371
372   # There is a chance that dvdauthor won't like some of the VOBs.
373   # We can't tell ahead of time which ones it will choke on. 
374   # So, we need to run it over and over again until it can process
375   # all the VOBs. If it can't handle one of them, run it through
376   # mencoder to fix it and try again. These errors are typically
377   # present due to the copy protection that ddrescue removed.
378   grep -q "SCR moves" $dvdauthorlog
379   while [ $? == 0 ]; do
380     # fix bad vobs that get the "SCR moves backwards" error:
381     #  STAT: Processing VTS_01_0.VOB...
382     #  ERR:  SCR moves backwards, remultiplex input.
383     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
384     if [[ ! -f "$badvob" ]]; then
385       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
386     fi
387     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
388     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
389     mv -f $badvob.fixed $badvob
390     echo "-> Creating DVD video $dest/$dvdname"
391     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
392     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
393     grep -q "SCR moves" $dvdauthorlog
394   done
395 }
396
397 function get_feature_title {
398   source="$1"
399   # if a feature title was given on the command line, use it
400   if [ $feature_title_override -ne 0 ]; then
401     feature_title=$feature_title_override
402     return 0
403   fi
404   # otherwise, use lsdvd to figure it out
405   if [ $ripdvd -eq 1 ]; then
406     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
407   else 
408     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
409   fi
410 }
411
412 function create_main_vob_with_cat {
413   # cd to the feature title DVD folder
414   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
415   if [ $? != 0 ]; then
416     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
417   fi
418
419   # concatenate all the VOBs together into 1 giant VOB
420   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
421   cat $vobs > "$tmpdir/$dvdname.VOB"
422
423   # cd back to the dir we started from
424   popd > /dev/null 2>&1
425 }
426
427 function create_main_vob_with_mplayer {
428
429   # argument processing  
430   source="$1"
431   remove_dumplog=$2
432
433   # make sure we have a valid feature title
434   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
435     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
436   fi
437
438   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
439   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
440     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
441     msg="$msg We also detected another condition that requires us to use dumpstream. "
442     msg="$msg\n    Unable to rip this DVD in the mode you requested."
443     fatal_and_exit "$msg"
444   fi
445
446   # use mplayer to create the main VOB file
447   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
448   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
449   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
450   if [ $? != 0 ]; then
451     cat $dumplog | grep -v "^A:" >> "$logfile"
452     fatal_and_exit "-E- Mplayer Failed"
453   fi
454   cat $dumplog | grep -v "^A:" >> "$logfile"
455   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
456 }
457
458 function get_audio_id_from_iso {
459   # Adjust our audio ID to find the english audio stream
460   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
461   aidcheck=`tempfile`
462   aid=128
463   mplayer -v -endpos 0 -dvd-device "$isofile" dvd://$feature_title > $aidcheck 2>&1
464   grep -q "aid: $aid" $aidcheck
465   while [ $? == 1 ] && [ $aid -lt 159 ]; do
466     (( aid = aid + 1 ))
467     grep -q "aid: $aid" $aidcheck
468   done
469   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
470   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
471   # mencoder default DVD audio track language selection (english)
472   lang_opts="-aid $aid -alang en"
473 }
474
475 function get_crop_from_iso { 
476   FRAMES=10000
477   echo "-> Detecting black frame border crop value from ISO file"
478   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
479   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
480   [[ -e "md5sums" ]] && rm -f "md5sums"
481   CROP=`cat $dumplog | grep CROP | tail -1`
482   echo "   Found crop value of $CROP" >> "$logfile"
483   CROP=${CROP#* crop=}
484   CROP=${CROP%%\).*}
485   typeset -i CROPCHECK
486   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
487   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
488   if [ -z "$CROP" ]; then
489     fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
490   fi
491   if [ $CROPCHECK -lt 0 ]; then 
492     CROP=""
493   else 
494     CROP=",crop=$CROP"
495   fi
496   echo "   Setting mencoder crop filter to: $CROP"
497 }
498
499 function get_audio_id_from_vob {
500   # Adjust our audio ID to find the english audio stream
501   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
502   aidcheck=`tempfile`
503   aid=128
504   mplayer -v -endpos 0 "$tmpdir/$dvdname.VOB" > $aidcheck 2>&1
505   grep -q "Found audio stream: $aid" $aidcheck
506   while [ $? == 1 ] && [ $aid -lt 159 ]; do
507     (( aid = aid + 1 ))
508     grep -q "Found audio stream: $aid" $aidcheck
509   done
510   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
511   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
512   # mencoder default DVD audio track language selection (english)
513   lang_opts="-aid $aid -alang en"
514 }
515
516 function check_vob_for_corrupted_start {
517   # check to see if the beginning of the DVD has a form of copy protection
518   # where they have deliberately broken the first X number of frames of the DVD.
519   # If we don't skip these, our resulting VOB file will not play.
520   badvobcheck=`tempfile`
521   endpos=360
522   skip=0
523   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
524   if [ $? != 0 ]; then
525     fatal_and_exit "-E- Mencoder Failed"
526   fi
527   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
528   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
529     (( skip = skip + 5 ))
530     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
531     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
532     if [ $? != 0 ]; then
533       fatal_and_exit "-E- Mencoder Failed"
534     fi
535     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
536   done
537   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
538
539   # cat the giant VOB into mencoder to create a playable VOB file
540   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
541   if [ $? != 0 ]; then
542     fatal_and_exit "-E- Mencoder Failed"
543   fi
544 }
545
546 function check_vob_for_completeness {
547   # check to make sure we got out a complete VOB.
548   # there is another kind of copy protection where the VOB's may
549   # have "MPG EOF" frames in the middle of the stream. 
550   # this causes mencoder to not process the entire VOB, and exit without any errors.
551   # detect this by seeing how much smaller the dst vob is from the src vob.
552   MAX_FILESIZE_DELTA_PERCENT=70
553   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
554   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
555   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
556   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
557     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
558     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
559     create_main_vob_with_mplayer "$isofile"
560     [[ -e "$dumplog" ]] && rm -f $dumplog
561     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
562     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
563     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
564       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
565     fi
566   fi
567 }
568
569 function check_vob_for_too_many_video_packets {
570   # If our earlier algorithm to work around this failed, throw an error.
571   # check to see if this DVD has a protection scheme we don't know how to work around
572   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
573   # for some reason, the video is black, while the audio rolls, then the video finally comes
574   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
575   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
576   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
577   grep -q "Too many video packets in the buffer:" "$logfile"
578   if [ $? == 0 ]; then
579     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
580     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
581     create_main_vob_with_mplayer "$isofile"
582     grep -q "Too many video packets in the buffer:" $dumplog
583     if [ $? == 0 ]; then
584       [[ -e "$dumplog" ]] && rm -f $dumplog
585       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
586     fi
587     [[ -e "$dumplog" ]] && rm -f $dumplog
588   fi
589 }
590
591 function check_vob_for_a52_crc_errors {
592   # Let's see if we can playback our newly created VOB file without any errors.
593   # if there are issues, let's detect them now, and try to recreate the VOB
594   # there are some forms of copy protection that have missed above, that evidence
595   # themselves when we try to playback the VOB file. This was added to deal with
596   # the "a52: CRC check failed" copy protection scheme.
597   MAX_ERRORS=10
598   ENDPOS=120
599   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
600   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
601   cat $dumplog | grep -v "^A:" >> "$logfile"
602   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
603   if [ $errors -gt $MAX_ERRORS ]; then
604     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
605     create_main_vob_with_mplayer "$isofile"
606     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
607     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
608     if [ $? != 0 ]; then
609       cat $dumplog | grep -v "^A:" >> "$logfile"
610       fatal_and_exit "-E- Mplayer Failed"
611     fi
612     cat $dumplog | grep -v "^A:" >> "$logfile"
613     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
614     if [ $errors -gt $MAX_ERRORS ]; then
615       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
616     fi
617   fi
618   [[ -e "$dumplog" ]] && rm -f $dumplog
619 }
620
621 function calculate_bitrate_from_target_size {
622   # determine what our bitrate needs to be if a target size was specified instead
623   if [ $target_size -ne 0 ]; then
624     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
625     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
626     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
627   fi
628 }
629
630 function create_dvdauthor_dvd_xml_file {
631   # make a dvdauthor xml menu file to create a valid DVD video from 
632   # this script does a good job, but we'll still need to clean it up a bit after it runs
633   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
634   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
635   if [ $? != 0 ]; then
636     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
637   fi
638
639   # replace the first line of the xml file to remove the bad dest path
640   awk -v line=1 -v new_content="<dvdauthor>" '{
641     if (NR == line) {
642       print new_content;
643     } else {
644       print $0;
645     }
646   }' dvd.xml > dvd.xml.new
647   mv -f dvd.xml.new dvd.xml
648   if [ $? != 0 ]; then
649     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
650   fi
651
652   # remove the "<video " property line from the xml file
653   cat dvd.xml | grep -v "<video" > dvd.xml.new
654   mv -f dvd.xml.new dvd.xml
655   if [ $? != 0 ]; then
656     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
657   fi
658   
659   # remove the extra <pgc>..</pgc> pairs
660   cat dvd.xml | awk 'BEGIN {x=1}
661   {
662     if ($0~"</pgc>") {x=0}
663     if (x==1) {print $0}
664     if ($0~"<pgc>") {x=1}
665   }' > dvd.xml.new
666   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
667   mv -f dvd.xml.new dvd.xml
668   if [ $? != 0 ]; then
669     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
670   fi
671
672   # remove the VTS_*_0.VOB file as this is just the main menu video clip
673   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
674   mv -f dvd.xml.new dvd.xml
675   if [ $? != 0 ]; then
676     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
677   fi
678 }
679
680 function check_for_mplayer_dumpstream_incompatibility {
681
682   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
683
684   if [ ! -e "$vobfile" ]; then
685     # mplayer dumpstream does not work on DVDs that obscure the feature title.
686     # A DVD that has 99 titles, where the longest title isn't the main feature
687     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
688     # out what the feature title is. This script will run through that flow if we
689     # set use_mplayer_dumpstream to 0. Check for this here.
690     if [ $ripdvd -eq 1 ]; then
691       lsdvd $dev | grep -q "Title: 99"
692     else
693       lsdvd "$isofile" | grep -q "Title: 99"
694     fi
695     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
696     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
697       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
698         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
699         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
700         invalid_feature_title=1
701       else 
702         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
703         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
704         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
705         use_mplayer_dumpstream=0
706         invalid_feature_title=1
707       fi
708       return
709     fi
710   fi
711
712   # There is another form of protection that causes the mplayer dumpstream to fail. 
713   # This can be detected by telling mplayer to parse the VOB file by copying its audio
714   # video streams to a dummy output file (/dev/null). Do that here to check for that 
715   # problem before continuing.
716   if [ -e "$vobfile" ]; then
717     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
718     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
719     grep -q "Too many audio packets in the buffer" $dumplog
720     if [ $? == 0 ]; then
721       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
722       use_mplayer_dumpstream=0
723       mplayer_dumpstream_incompatibility=1
724     fi
725     [[ -e "$dumplog" ]] && rm -f $dumplog
726   fi
727 }
728
729 function fill_mythvideo_metadata {
730
731   # This function must be passed the filename as an argument
732   # The filename must be a full path to the file
733   filename="$1"
734
735   # Make sure the fill mythvideo metadata option has been set to 1
736   if [ $fill_mythvideo_metadata -eq 0 ]; then
737     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
738     return 0
739   fi
740
741   # If the fill mythvideo metadata script is present, run it
742   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
743   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
744     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
745     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
746   else
747     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
748     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
749   fi
750 }
751
752 function remove_intermediate_vob_file {
753   # remove the intermediate VOB file
754   if [ $keep_intermediate_files -eq 0 ]; then
755     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
756   else
757     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
758   fi
759 }
760
761 function remove_intermediate_iso_file {
762   # remove the original DVD image 
763   if [ $keep_intermediate_files -eq 0 ]; then
764     [[ -e "$isofile" ]] && rm "$isofile"
765   else
766     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
767   fi
768 }
769
770 function remove_intermediate_dvdbackup_folder {
771   if [ $keep_intermediate_files -eq 0 ]; then
772     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
773   else
774     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
775   fi
776 }
777
778 ###############################################
779 # MAIN
780
781 # Make a note of when this DVD rip started
782 date=`date`
783 echo -e "\n$date DVD rip started" >> "$logfile"
784
785 # Rip the DVD - Mirror Mode
786 if [ $mirror_mode -eq 1 ]; then
787   echo "-> Ripping DVD $dvdname to $dest"
788
789   # use ddrescue to make an ISO image of the disk
790   make_dvd_iso_image "$dest/$dvdname.iso"
791
792   # add this video data to the mythtv DB
793   fill_mythvideo_metadata "$dest/$dvdname.iso" 
794
795   # eject the disk upon completion
796   eject -T $dev
797
798   date=`date`
799   echo "$date DVD rip completed" | tee -a "$logfile"
800
801   if [[ -n "$mailto" ]]; then
802     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
803   fi
804
805 fi
806
807 # Rip the DVD - Main Title Feature Only
808 if [ $mirror_mode -eq 0 ]; then
809
810   # Rip image from DVD
811   if [ $ripdvd -eq 1 ]; then
812     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
813     # use ddrescue to make an ISO image of the disk
814     make_dvd_iso_image "$tmpdir/$dvdname.iso"
815   fi
816
817   # Rip image from DVD path
818   if [ -n "$dvdpath" ]; then
819     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
820     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
821   fi
822
823   # make sure our isofile value is set
824   if [ -z "$isofile" ]; then
825     isofile="$tmpdir/$dvdname.iso"
826   fi
827      
828   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
829
830     if [ ! -e "$vobfile" ]; then
831       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
832       
833       # get the feature title from the ISO
834       get_feature_title "$isofile"
835  
836       # get the crop value from the ISO
837       get_crop_from_iso
838
839       # check for mplayer dumpstream incompatibilities
840       # if they exist, this method will set this mode to 0.
841       check_for_mplayer_dumpstream_incompatibility
842
843       if [ $use_mplayer_dumpstream -eq 1 ]; then 
844
845         # get our audio id from the ISO file
846         get_audio_id_from_iso
847
848         # create our main VOB file from the ISO
849         create_main_vob_with_mplayer "$isofile"
850      
851         # remove the intermediate VOB file
852         remove_intermediate_vob_file
853
854         # it's possible that our VOB is still corrupted in some manner
855         # check to make sure it is still a good VOB before continuing.
856         check_for_mplayer_dumpstream_incompatibility
857
858       fi
859  
860       if [ $use_mplayer_dumpstream -eq 0 ]; then 
861
862         # use dvdbackup to make a DVD folder of the feature title
863         make_dvdbackup_folder_image
864   
865         # create our main VOB file
866         create_main_vob_with_cat
867
868         # get our audio id from the VOB file
869         get_audio_id_from_vob
870   
871         # check for corrupted VOB start
872         check_vob_for_corrupted_start
873  
874         # check to make sure our VOB is complete
875         check_vob_for_completeness
876
877         # check to make sure our VOB doesn't have too many video packets
878         check_vob_for_too_many_video_packets
879
880         # check to make sure our VOB doesn't have a52 crc errors
881         check_vob_for_a52_crc_errors
882
883         # remove the intermediate VOB file
884         remove_intermediate_vob_file
885
886       fi
887
888       # remove the intermediate ISO file
889       remove_intermediate_iso_file
890
891     else
892       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
893     fi
894
895     # transcode the DVD
896     if [ $make_final_dest_avi -eq 1 ]; then
897       echo "-> Encoding the DVD video to an AVI file" | tee -a "$logfile"
898
899       # determine what our bitrate needs to be if a target size was specified instead
900       calculate_bitrate_from_target_size        
901       
902       # There was a lot of experimentation to arrive at these values
903       # These seem to work OK for me. If they don't work for you, feel
904       # free to adjust/change as needed.
905
906       # Edit these as needed to suite your needs
907       mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
908       mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
909       mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP"
910       mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS:chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:bitrate=$target_bitrate:autoaspect:threads=2"
911
912       # There are a number of different ways to encode 6 channel audio.
913       # I've loaded 3 different ways into the mencoder_audioch_opts.
914       # It will cycle through them until it finds one that works. 
915       # You can change the order to suit your needs.
916       if [ $audio_2ch -eq 0 ]; then
917
918         # These options produce good 6 channel audio for the internal mythvideo player, but they can't play in Windows.
919         #mencoder_audio_opts="-oac lavc -lavcopts acodec=ac3"
920         #mencoder_audioch_opts[0]="-channels 6 -af channels=6:6:0:5:1:4:2:3:3:2:4:1:5:0"
921
922         # These options produce good 6 channel audio for linux and windows (except the internal mythvideo player)
923         # This option requires playback under linux with mplayer to be done with options: -channels 6 -ac hwac3,hwdts,mad 
924         mencoder_audio_opts="-oac copy"
925
926         # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
927         mencoder_audioch_opts[0]="-channels 6 -af channels=6"
928         mencoder_audioch_opts[1]="-af channels=6"
929         mencoder_audioch_opts[2]=""
930
931      else 
932         # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
933         mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
934         mencoder_audioch_opts[0]=""
935      fi
936
937       # Do not edit this line. $mencoder_video_encoder_opts must be last
938       mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
939       mencoder_retval=0
940
941       for PASS in 1 2 
942       do 
943         # Set some options based on which pass we are in
944         mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
945         [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
946         [ $PASS -eq 1 ] && output_file="/dev/null"
947         [ $PASS -eq 2 ] && output_file="$dest/$dvdname.avi"
948   
949         # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
950         for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
951         do
952           echo -e "   Encoding pass $PASS"
953           echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
954           mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
955           mencoder_retval=$? 
956           grep -q "\[channels\] Invalid" $encodelog
957           if [ $? != 0 ]; then      
958             break;
959           else
960             echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
961           fi
962         done
963         if [ $mencoder_retval != 0 ]; then
964           fatal_and_exit "-E- Unhandled mencoder error"
965         fi
966         # Concatenate the encode log to our main log file, greping out unwanted lines
967         cat $encodelog | grep -v "Pos:" >> "$logfile"
968       done
969
970       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
971         [[ -e "$vobfile" ]] && rm -f "$vobfile";
972         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
973       else
974         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
975         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
976       fi
977     fi
978
979   # add this video data to the mythtv DB
980   [ $make_final_dest_avi -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.avi" 
981   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
982     
983   else
984
985   # use dvdbackup to make a DVD folder of the feature title
986   make_dvdbackup_folder_image
987
988   # cd to the feature title DVD folder
989   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
990   if [ $? != 0 ]; then
991     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
992   fi
993   
994   # create the dvd.xml file for dvdauthor
995   create_dvdauthor_dvd_xml_file  
996
997   # make the final DVD folder image
998   make_dvdauthor_folder_image
999
1000   # add this video data to the mythtv DB
1001   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1002  
1003   # cd back to the dir we started from
1004   popd > /dev/null 2>&1
1005
1006   if [ $make_final_dest_iso -eq 1 ]; then
1007
1008     # make an iso image out of our directory
1009     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1010    
1011     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1012     if [ -s "$dest/$dvdname.iso" ]; then
1013       if [ $make_final_dest_folder -eq 0 ]; then
1014         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1015         # remove the folder of the DVD image now that we have a .iso version of it
1016         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1017       fi
1018     else
1019       # we created an empty iso file, remove it
1020       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1021       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1022       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1023     fi
1024  
1025     # add this video data to the mythtv DB
1026     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1027
1028   fi
1029
1030   fi
1031
1032   # remove the ddrescue DVD ISO image
1033   remove_intermediate_iso_file
1034
1035   # remove the tmp dvdbackup folder of the DVD image
1036   remove_intermediate_dvdbackup_folder
1037
1038   # eject the DVD disk upon completion
1039   [ $ripdvd -eq 1 ] && eject -T $dev
1040
1041   date=`date`
1042   echo "$date DVD rip completed" | tee -a "$logfile"
1043
1044   if [[ -n "$mailto" ]]; then
1045     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1046   fi
1047
1048 fi
1049